From e52c1364063605198ce26708dcb44dc3066df7f2 Mon Sep 17 00:00:00 2001
From: Starbeamrainbowlabs <sbrl@starbeamrainbowlabs.com>
Date: Thu, 7 Nov 2019 19:04:05 +0000
Subject: [PATCH] Fix bugs in performance improvement

---
 build                                               |  8 ++------
 logic/Actions/ListReadingTypes.php                  |  4 ++--
 logic/Repositories/IMeasurementTypeRepository.php   |  2 +-
 .../MariaDBMeasurementTypeRepository.php            | 13 +++++++++----
 4 files changed, 14 insertions(+), 13 deletions(-)

diff --git a/build b/build
index 3471a37..a048a44 100755
--- a/build
+++ b/build
@@ -28,7 +28,7 @@ cache_dir="./.cache";
 build_output_folder="./app";
 
 # Database settings for ssh port forwarding task
-database_host="aq.connectedhumber.org";
+database_host="db.connectedhumber.org";
 database_name="aq_db";
 database_user="www-data";
 
@@ -37,7 +37,7 @@ min_npm_version_major="6";
 
 # Deployment settings
 deploy_ssh_user="ci";
-deploy_ssh_host="sensors.connectedhumber.org";
+deploy_ssh_host="aq.connectedhumber.org";
 deploy_ssh_port="22";
 
 deploy_root_dir="Air-Quality-Web";
@@ -378,10 +378,6 @@ SFTPCOMMANDS
 		
 		echo "ln -s \"../data\" \"${deploy_root_dir}/www-new/data\"";
 		
-		if [ "${GIT_REF_NAME}" == "refs/heads/master" ]; then
-			echo "ln -s \"../../Air-Quality-Web-Beta/www/\" \"${deploy_root_dir}/www-new/beta\"";
-		fi
-		
 		echo "mv \"${deploy_root_dir}/www\" \"${deploy_root_dir}/www-old\"";
 		echo "mv \"${deploy_root_dir}/www-new\" \"${deploy_root_dir}/www\"";
 		echo "rm -r \"${deploy_root_dir}/data/cache\"";
diff --git a/logic/Actions/ListReadingTypes.php b/logic/Actions/ListReadingTypes.php
index 99086d9..83de6b3 100644
--- a/logic/Actions/ListReadingTypes.php
+++ b/logic/Actions/ListReadingTypes.php
@@ -54,7 +54,7 @@ class ListReadingTypes implements IAction {
 		if(!is_int($device_id))
 			$data = $this->types_repo->get_all_types();
 		else
-			$data = $this->types_repo->get_types_by_device($device_id. $days_to_analyse);
+			$data = $this->types_repo->get_types_by_device($device_id, $days_to_analyse);
 		$this->perfcounter->end("sql");
 		
 		// 1.5: Validate data from database
@@ -86,7 +86,7 @@ class ListReadingTypes implements IAction {
 		// Don't a cache control header, because new types might get added at any time
 		// TODO: Investigate adding a short-term (~10mins?) cache-control header here
 		
-		header("content-length: " . strlen($response));
+		// header("content-length: " . strlen($response));
 		header("content-type: $response_type");
 		header("content-disposition: inline; filename=$response_suggested_filename");
 		header("x-time-taken: " . $this->perfcounter->render());
diff --git a/logic/Repositories/IMeasurementTypeRepository.php b/logic/Repositories/IMeasurementTypeRepository.php
index f1f07e0..232dbc3 100644
--- a/logic/Repositories/IMeasurementTypeRepository.php
+++ b/logic/Repositories/IMeasurementTypeRepository.php
@@ -36,5 +36,5 @@ interface IMeasurementTypeRepository {
 	 * @param	int			$day_to_analyse	The number of days worth fo data to analyse. Defaults to -1, which is everything. Set to 0 for readings recorded in the last 24 hours, which is much faster.
 	 * @return	string[]	A list of device ids.
 	 */
-	public function get_types_by_device(int $device_id, int $days_to_analyse);
+	public function get_types_by_device(int $device_id, int $days_to_analyse = -1);
 }
diff --git a/logic/Repositories/MariaDBMeasurementTypeRepository.php b/logic/Repositories/MariaDBMeasurementTypeRepository.php
index 46db5ee..7643f40 100644
--- a/logic/Repositories/MariaDBMeasurementTypeRepository.php
+++ b/logic/Repositories/MariaDBMeasurementTypeRepository.php
@@ -82,6 +82,12 @@ class MariaDBMeasurementTypeRepository implements IMeasurementTypeRepository {
 	}
 	
 	public function get_types_by_device($device_id, $days_to_analyse = -1) {
+		$data = [
+			"device_id" => $device_id
+		];
+		if($days_to_analyse >= 0)
+			$data["days"] = $days_to_analyse;
+		
 		$s = $this->get_static;
 		$o = $this->get_static_extra;
 		return $this->database->query(
@@ -95,10 +101,9 @@ class MariaDBMeasurementTypeRepository implements IMeasurementTypeRepository {
 				{$s("table_name")}.{$s("column_id")} = {$o(MariaDBMeasurementDataRepository::class, "table_name_values")}.{$o(MariaDBMeasurementDataRepository::class, "column_values_reading_type")}
 			WHERE
 				{$o(MariaDBMeasurementDataRepository::class, "table_name_metadata")}.{$o(MariaDBMeasurementDataRepository::class, "column_metadata_device_id")} = :device_id
-				" . ($days_to_analyse >= 0 ? "AND and DATEDIFF(NOW(),s_or_r) = 0" : "") . "
-			GROUP BY {$s("table_name")}.{$s("column_id")};", [
-				"device_id" => $device_id
-			]
+				" . ($days_to_analyse >= 0 ? "AND DATEDIFF(NOW(),s_or_r) = :days" : "") . "
+			GROUP BY {$s("table_name")}.{$s("column_id")};",
+			$data
 		)->fetchAll();
 	}
 }
